/*
 * Correction de l'exercice 1 
 */

/**
 * coupe une chaîne si sa taille dépasse un certaine longueur, et en cas de 
 * coupure la fin de la chaîne est remplacée par une chaîne passée en paramètre.
 * 
 * @param {str} str la chaîne à couper si elle est trop longue
 * @param {str} maxlength la longueur maximale qui ne doit pas être dépassée
 * @param {str} [endstr="..."] la chaîne de remplacement à mettre a fin de chaîne au 
 *        cas où la chaîne est coupée
 * @returns la chaîne originale si sa taille est <= à maxlength ou bien
 *        la chaîne tronquée de manière à ce que sa longueur soit égale à 
 *        maxlength et qu'elle se termine par la chaîne endstr.
 * 
 * exemples :
 * 
 * truncate("0123456789", 14, "....")    -->  "0123456789"   
 * la chaîne est plus courte que maxlength , elle n'est pas tronquée
 *   
 * truncate("0123456789", 7, "....")      -->  "012...."
 * la chaîne est plus longue que 7, elle est tronquée de manière à ce que
 * la chaîne tronquée + "...." ait une longueur de 7
 * 
 * truncate("0123456789", 7)      -->  "0123..."
 * la chaîne est plus longue que 7, elle est tronquée de manière à ce que
 * la chaîne tronquée + "..." (valeur par défaut) ait une longueur de 7
 */
function truncate(str, maxlength, endstr = "...") { 
   return (str.length >= (maxlength) ?
       (str.slice(0, maxlength - endstr.length) + endstr) : str);
}


/**
 * fonction de test pour faire des traces d'exécution
 * @param {str} str la chaîne à couper si elle est trop longue
 * @param {str} maxlength la longueur maximale qui ne doit pas être dépassée
 * @param {str} [endstr] la chaîne de remplacement à mettre a fin de chaîne au 
 *        cas où la chaîne est coupée
 */
function test(str, maxlength,endstr) {
    console.log("\nla chaîne originale :\n" + str);
    console.log(`la chaîne tronquée (maxlength = ${maxlength}, endstr = ${(endstr)?endstr:"... (valeur par défaut)"})`);
    if (endstr) {
        console.log(truncate(str,maxlength,endstr));
    } else {
        console.log(truncate(str,maxlength));
    }
}


test("0123456789", 14, "....");
test("0123456789", 7, "....");
test("0123456789", 7);